use std::collections::HashSet;
use std::{fs, io::BufRead, io::BufReader};

pub fn solve() {
    let path = "res/04/input";

    //let contents = fs::read_to_string(path).expect("I/O error, wrong path?");
    let contents = BufReader::new(fs::File::open(path).expect("I/O error, wrong path?"));

    let cards = contents
        .lines()
        .map(|l| {
            if let Ok(line) = l {
                let words = line.split_whitespace().collect::<Vec<&str>>();
                let winning_nums = words[2..12]
                    .iter()
                    .map(|s| s.parse::<usize>().unwrap())
                    .collect::<HashSet<usize>>();

                let own_nums = words[13..words.len()]
                    .iter()
                    .map(|s| s.parse::<usize>().unwrap())
                    .filter(|u| winning_nums.contains(u))
                    .count();
                return own_nums;
            }
            0
        })
        .collect::<Vec<usize>>();

    let result: usize = cards
        .iter()
        .filter(|i| **i > 0)
        .map(|i| 2usize.pow(*i as u32 - 1))
        .sum();

    println!("Result 1: {}", result);

    let mut card_counts: Vec<usize> = vec![1; cards.len()];
    for i in 0..cards.len() {
        for j in i + 1..i + 1 + cards[i] {
            if j >= cards.len() {
                continue;
            }
            card_counts[j] += card_counts[i]
        }
    }

    let result: usize = card_counts.iter().sum();

    println!("Result 2: {}", result);
}
