use std::fs;

pub fn solve() {
    let path = "res/09/input";

    let contents = fs::read_to_string(path).expect("I/O error, wrong path?");
    //let contents = BufReader::new(fs::File::open(path).expect("I/O error, wrong path?"));

    let mut sequences: Vec<Vec<i32>> = contents
        .lines()
        .map(|line| {
            line.split_whitespace()
                .map(|num| num.parse::<i32>().unwrap())
                .collect::<Vec<i32>>()
        })
        .collect();

    let mut last_values: Vec<Vec<i32>> =
        sequences.iter().map(|s| vec![*s.last().unwrap()]).collect();

    let mut first_values: Vec<Vec<i32>> = sequences
        .iter()
        .map(|s| vec![*s.first().unwrap()])
        .collect();

    sequences
        .iter_mut()
        .enumerate()
        .for_each(|(i_sequence, sequence)| {
            while sequence.iter().any(|num| *num != 0) {
                for i in 0..sequence.len() - 1 {
                    sequence[i] = sequence[i + 1] - sequence[i]
                }
                sequence.pop();
                last_values[i_sequence].push(*sequence.last().unwrap());
                first_values[i_sequence].push(*sequence.first().unwrap());
            }
        });

    let result: i32 = last_values.iter().map(|seq| seq.iter().sum::<i32>()).sum();

    println!("Result 1: {result}");

    let result: i32 = first_values
        .iter()
        .map(|seq| seq.iter().rev().fold(0, |x, y| y - x))
        .sum();

    println!("Result 2: {}", result);
}
