use std::{collections::HashSet, fs};

pub fn solve() {
    let path = "res/10/input";

    let contents = fs::read_to_string(path).expect("I/O error, wrong path?");
    //let contents = BufReader::new(fs::File::open(path).expect("I/O error, wrong path?"));

    let mut pos: (usize, usize) = (0, 0);

    let grid: Vec<Vec<char>> = contents
        .lines()
        .map(|line| line.chars().collect::<Vec<char>>())
        .collect();

    grid.iter().enumerate().for_each(|(i_row, row)| {
        if let Some(col) = row.iter().position(|c| *c == 'S') {
            pos = (i_row, col)
        }
    });

    let mut coords: Vec<(usize, usize)> = vec![pos];

    if pos.0 > 0 {
        if ['|', '7', 'F'].contains(&grid[pos.0 - 1][pos.1]) {
            pos = (pos.0 - 1, pos.1)
        }
    }
    if pos.1 > 0 {
        if ['-', 'L', 'F'].contains(&grid[pos.0][pos.1 - 1]) {
            pos = (pos.0, pos.1 - 1)
        }
    }
    if pos.0 < grid.len() - 1 {
        if ['|', 'J', 'L'].contains(&grid[pos.0 + 1][pos.1]) {
            pos = (pos.0 + 1, pos.1)
        }
    }
    if pos.1 < grid[0].len() - 1 {
        if ['-', '7', 'J'].contains(&grid[pos.0][pos.1 + 1]) {
            pos = (pos.0, pos.1 + 1)
        }
    }

    while grid[pos.0][pos.1] != 'S' {
        coords.push(pos);
        pos = match grid[pos.0][pos.1] {
            '|' => {
                if *coords.iter().rev().nth(1).unwrap() != (pos.0 - 1, pos.1) {
                    (pos.0 - 1, pos.1)
                } else {
                    (pos.0 + 1, pos.1)
                }
            }
            '-' => {
                if *coords.iter().rev().nth(1).unwrap() != (pos.0, pos.1 - 1) {
                    (pos.0, pos.1 - 1)
                } else {
                    (pos.0, pos.1 + 1)
                }
            }
            'J' => {
                if *coords.iter().rev().nth(1).unwrap() != (pos.0 - 1, pos.1) {
                    (pos.0 - 1, pos.1)
                } else {
                    (pos.0, pos.1 - 1)
                }
            }
            '7' => {
                if *coords.iter().rev().nth(1).unwrap() != (pos.0, pos.1 - 1) {
                    (pos.0, pos.1 - 1)
                } else {
                    (pos.0 + 1, pos.1)
                }
            }
            'F' => {
                if *coords.iter().rev().nth(1).unwrap() != (pos.0, pos.1 + 1) {
                    (pos.0, pos.1 + 1)
                } else {
                    (pos.0 + 1, pos.1)
                }
            }
            'L' => {
                if *coords.iter().rev().nth(1).unwrap() != (pos.0 - 1, pos.1) {
                    (pos.0 - 1, pos.1)
                } else {
                    (pos.0, pos.1 + 1)
                }
            }
            _ => {
                panic!();
            }
        };
    }

    let result = coords.len() / 2;

    println!("Result 1: {}", result);

    let set: HashSet<(usize, usize)> = HashSet::from_iter(coords.iter().cloned());
    let mut corners: Vec<(usize, usize, Vec<u8>, Vec<u8>)> = vec![];

    let mut set1 = HashSet::<(usize, usize)>::new();
    let mut set2 = HashSet::<(usize, usize)>::new();

    let first_corners = (vec![0], vec![1, 2, 3]); //c_to_corners(grid[coords[0].0][coords[0].1]);

    corners.push((coords[0].0, coords[0].1, first_corners.0, first_corners.1));
    for c in coords.iter().skip(1) {
        let c_corners = c_to_corners(grid[c.0][c.1]);
        let last = corners.last().unwrap();
        if last.0 < c.0 {
            // old above
            if last.2.contains(&2) && c_corners.0.contains(&0)
                || last.2.contains(&3) && c_corners.0.contains(&1)
            {
                // 0,1,2 3 -> 2,3,0  1    1 0,2,3
                corners.push((c.0, c.1, c_corners.0, c_corners.1))
            } else {
                corners.push((c.0, c.1, c_corners.1, c_corners.0))
            }
        } else if last.0 > c.0 {
            // old below
            if last.2.contains(&0) && c_corners.0.contains(&2)
                || last.2.contains(&1) && c_corners.0.contains(&3)
            {
                corners.push((c.0, c.1, c_corners.0, c_corners.1))
            } else {
                corners.push((c.0, c.1, c_corners.1, c_corners.0))
            }
        } else if last.1 < c.1 {
            // old left
            if last.2.contains(&1) && c_corners.0.contains(&0)
                || last.2.contains(&3) && c_corners.0.contains(&2)
            {
                // 0,2,3 1 -> 1,2,3 0    0,1 2,3
                corners.push((c.0, c.1, c_corners.0, c_corners.1))
            } else {
                corners.push((c.0, c.1, c_corners.1, c_corners.0))
            }
        } else {
            // old right
            if last.2.contains(&0) && c_corners.0.contains(&1)
                || last.2.contains(&2) && c_corners.0.contains(&3)
            {
                corners.push((c.0, c.1, c_corners.0, c_corners.1))
            } else {
                corners.push((c.0, c.1, c_corners.1, c_corners.0))
            }
        }
    }

    for c in corners {
        adj_pos(
            (c.0, c.1, c.2),
            &mut set1,
            &set,
            grid.len() - 1,
            grid[0].len() - 1,
        );
        adj_pos(
            (c.0, c.1, c.3),
            &mut set2,
            &set,
            grid.len() - 1,
            grid[0].len() - 1,
        );
    }

    /*
    for i in 0..grid.len() {
        for j in 0..grid[0].len() {
            if set2.contains(&(i,j)) {
                print!("X")
            } else if set.contains(&(i,j)) {
                print!("{}", grid[i][j])
            } else {
                print!(".")
            }
        }
        print!("\n")
    }*/
    let result = set1.len().min(set2.len());

    println!("Result 2: {result}");
}

fn adj_pos(
    c: (usize, usize, Vec<u8>),
    set: &mut HashSet<(usize, usize)>,
    edge: &HashSet<(usize, usize)>,
    max_row: usize,
    max_col: usize,
) {
    let mut pos: Vec<(usize, usize)> = vec![];
    if c.2.contains(&0) && c.2.contains(&1) && c.0 > 0 {
        pos.push((c.0 - 1, c.1))
    }
    if c.2.contains(&2) && c.2.contains(&3) && c.0 < max_row {
        pos.push((c.0 + 1, c.1))
    }
    if c.2.contains(&0) && c.2.contains(&2) && c.1 > 0 {
        pos.push((c.0, c.1 - 1))
    }
    if c.2.contains(&1) && c.2.contains(&3) && c.1 < max_col {
        pos.push((c.0, c.1 + 1))
    }
    while !pos.is_empty() {
        let curr = pos.pop().unwrap();
        if set.contains(&curr) || edge.contains(&curr) {
            continue;
        }
        let mut q: Vec<(usize, usize)> = vec![curr];
        while !q.is_empty() {
            let curr = q.pop().unwrap();
            if set.contains(&curr) || edge.contains(&curr) {
                continue;
            }
            set.insert(curr);

            if curr.0 > 0 {
                q.push((curr.0 - 1, curr.1))
            }
            if curr.0 < max_row {
                q.push((curr.0 + 1, curr.1))
            }
            if curr.1 > 0 {
                q.push((curr.0, curr.1 - 1))
            }
            if curr.1 < max_col {
                q.push((curr.0, curr.1 + 1))
            }
        }
    }
}

fn c_to_corners(c: char) -> (Vec<u8>, Vec<u8>) {
    match c {
        '|' => (vec![0, 2], vec![1, 3]),
        '-' => (vec![0, 1], vec![2, 3]),
        'J' => (vec![1, 2, 3], vec![0]),
        '7' => (vec![0, 1, 3], vec![2]),
        'F' => (vec![0, 1, 2], vec![3]),
        'L' => (vec![0, 2, 3], vec![1]),
        _ => {
            panic!("{c}");
        }
    }
}
