use std::{collections::HashMap, fs};

pub fn solve() {
    let path = "res/15/input";

    let mut contents = fs::read_to_string(path).expect("I/O error, wrong path?");
    //let contents = BufReader::new(fs::File::open(path).expect("I/O error, wrong path?"));

    contents.retain(|c| !c.is_whitespace());
    let result: usize = contents
        .split(',')
        .map(|p| p.chars().fold(0, |x, y| ((x + y as usize) * 17) % 256))
        .sum();

    println!("Result 1: {result}");

    let mut boxes: HashMap<usize, Vec<(&str, usize)>> = HashMap::new();
    for p in contents.split(',') {
        let (t, n) = match p.contains('=') {
            true => {
                let (t, n) = p.split_once('=').unwrap();
                (t, n.parse::<usize>().unwrap())
            }
            false => {
                let (t, _) = p.split_once('-').unwrap();
                (t, 0usize)
            }
        };
        let i = t.chars().fold(0, |x, y| ((x + y as usize) * 17) % 256);

        let v = boxes.entry(i).or_insert(vec![]);
        if n == 0 {
            if v.iter().any(|(p, _)| *p == t) {
                v.remove(v.iter().position(|(p, _)| *p == t).unwrap());
            }
        } else {
            if v.iter().any(|(p, _)| *p == t) {
                let pos = v.iter().position(|(p, _)| *p == t).unwrap();
                v[pos] = (t, n);
            } else {
                v.push((t, n))
            }
        }
    }
    let result: usize = boxes
        .iter()
        .map(|(k, v)| {
            v.iter()
                .enumerate()
                .map(|(i, (_, n))| (k + 1) * (i + 1) * n)
                .sum::<usize>()
        })
        .sum();

    println!("Result 2: {result}");
}
